import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Jet_fighter extends PApplet {


Jet jet1 = new Jet();
Jet jet2 = new Jet();
ArrayList<Bullet> bulletList;
float textposx = height/2;
float textposy = width/2;
int state = 0;

public void setup()
{
    fill(150);
    
    jet1.setupjet(200, 450);
    jet2.setupjet(600, 450);
    bulletList = new ArrayList<Bullet>();
}

public void draw()
{ 
    {
        if (state == 0) {
            game();
        } else if (state == 1) {
            gameOver1();
        } else if (state == 2) {
            gameOver2();
        }
    }
}

public void game() 

{
    background(150);
    jet1.drawjet();
    jet2.drawjet();


    for (int i = bulletList.size()-1; i>=0; i--) {
        Bullet localBullet = bulletList.get(i);

        if (localBullet.hitJet(jet1))
        {
            println("Jet 2 Won");
            state = 2;
        }

        if (localBullet.hitJet(jet2))
        {
            println("Jet 1 Won");
            state = 1;
        }

        if (localBullet.isOutOfWindow()) {
            bulletList.remove(i);
        }

        localBullet.movement();
        localBullet.display();
    }
}

public void gameRestart()
{
    state = 0;
}


public void gameOver1() { //state 1
    background(255, 0, 0);
    textSize(30);
    text("Jet 1 WON", 250, 150);
    text("Click the mouse to restart", 250, 200);
}
public void gameOver2() { //state 1
    background(255, 0, 0);
    textSize(30);
    text("Jet 2 WON", 250, 150);
    text("Click the mouse to restart", 250, 200);
    if (mousePressed) 
    {
        state = -1;
    }
}
class Bullet{
    
    //class variables
    float posX;
    float posY;
    float velX = 7*cos(radians(jet1.angle));
    float velY = 7*sin(radians(jet1.angle));
    //constructor
    Bullet(float _posX, float _posY)
    {
        posX = _posX;
        posY = _posY;
    }
    
    //class functions    
    public void movement(){
        posX = posX + velX;
        posY = posY + velY;
    }
    
    public void display(){
        ellipse(posX, posY, 5, 5);
       
    }
    
    
    
     public boolean hitJet(Jet testJet) {
    if (dist(posX, posY, testJet.posx, testJet.posy) < 3+7) {
      return true;
    } else {
      return false;
    }
  }
    
    
     public boolean isOutOfWindow() {
    if (posX < 0 || posX > width || posY < 0 || posY > height) {
      return true;
    } else {
      return false;
    }
  }
    
    
}
class Jet {
    float posx =0;
    float posy = 0;
    float angle = -90;
    float anglespeed = 0;
    int speed = 3;

    public void setupjet(float x, float y)
    {
        posx = x;
        posy = y;
    }



    public void drawjet    ()
    {
        angle+=anglespeed;


        fill(0);
        pushMatrix();
        translate(posx, posy);
        rotate(radians(angle+90));
        stroke(255);
        noFill();
        line(0, -10, 10, 10);
        line(10, 10, 0, 5);
        line(0, 5, -10, 10);
        line(-10, 10, 0, -10);
        popMatrix();
    }


}
public void keyPressed()
{

    if (keyCode == LEFT) jet1.anglespeed = -4;
    if (keyCode == RIGHT) jet1.anglespeed = 4;
    if (keyCode == UP) 
    {
        jet1.posx += 5*cos(radians(jet1.angle));
        jet1.posy += 5*sin(radians(jet1.angle));
    }

    if (key == 'a') jet2.anglespeed = -4;
    if (key == 'd') jet2.anglespeed = +4;
    if (key == 'w')
    {
        jet2.posx += 5*cos(radians(jet2.angle));
        jet2.posy += 5*sin(radians(jet2.angle));
    }

    if (key=='-') {
        bulletList.add(new Bullet(jet1.posx+10, jet1.posy+10));
        println(bulletList.size());
    }
    if (key==' ') {
        bulletList.add(new Bullet(jet2.posx+10, jet2.posy+10));
        println(bulletList.size());
    }
    
}

public void keyReleased()
{
    if (keyCode == LEFT) jet1.anglespeed= 0;
    if (keyCode == RIGHT) jet1.anglespeed= 0;
    if (key == 'a') jet2.anglespeed = 0;
    if (key == 'd') jet2.anglespeed = 0;
}
    public void settings() {  size (800, 600); }
    static public void main(String[] passedArgs) {
        String[] appletArgs = new String[] { "Jet_fighter" };
        if (passedArgs != null) {
          PApplet.main(concat(appletArgs, passedArgs));
        } else {
          PApplet.main(appletArgs);
        }
    }
}
